﻿//-----------------------------------------------------------------------------------------------------------
//
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
// KIND, WHETHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
// PURPOSE.
//
//------------------------------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using org.apache.hadoop.hbase;
using org.apache.hadoop.hbase.client;
using org.apache.hadoop.hbase.util;
using org.apache.hadoop.conf;


namespace LoadData
{
    class Program
    {
        static void Main(string[] args)
        {
            com.jnbridge.jnbproxy.JNBRemotingConfiguration.specifyRemotingConfiguration(
                               com.jnbridge.jnbproxy.JavaScheme.sharedmem
                               , @"C:\Program Files\Java\jre6\bin\client\jvm.dll"
                               , @"C:\Program Files\JNBridge\JNBridgePro v6.0\jnbcore\jnbcore.jar"
                               , @"C:\Program Files\JNBridge\JNBridgePro v6.0\jnbcore\bcel-5.1-jnbridge.jar"
                               , @"C:\Data\business\prototypes\HBase\jars\cdh4Jars\zookeeper-3.4.3-cdh4.0.0.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\log4j-1.2.16.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\hbase-0.92.1-cdh4.0.0-security.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\hadoop-core-2.0.0-mr1-cdh4.0.0.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\hadoop-common-2.0.0-cdh4.0.0.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\guava-11.0.2.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\commons-logging-1.1.1.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\commons-lang-2.5.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\jackson-mapper-asl-1.5.5.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\slf4j-api-1.6.1.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\jackson-core-asl-1.5.5.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\commons-configuration-1.6.jar;C:\Data\business\prototypes\HBase\jars\cdh4Jars\hadoop-auth-2.0.0-cdh4.0.0.jar");
            Configuration hbaseConfig = HBaseConfiguration.create();
            hbaseConfig.set("hbase.zookeeper.quorum", "192.168.1.3");
            //HConnection connection = HConnectionManager.createConnection(hbaseConfig);
            HBaseAdmin admin = new HBaseAdmin(hbaseConfig);
            HTableDescriptor desc = new HTableDescriptor("access_logs");
            HColumnDescriptor colmnDesc = new HColumnDescriptor("details");
            desc.addFamily(colmnDesc);
            admin.createTable(desc);
            HTable htable = new HTable(hbaseConfig, "access_logs");
            htable.setAutoFlush(false);
            htable.setWriteBufferSize(1024 * 1024 * 12);
            int totalRecords = 100000;
            Random rand = new Random();
            string[] pages = { "/dogs.html", "/cats.html", "/rats.html", "/bats.html", "/zebras.html", "/t-rex.html", "/lizard.html", "/birds.html", "/beetles.html", "/elephants.html"};
            string[] ipAdrs = { "88.240.129.183", "144.122.180.55", "85.100.75.104", "78.34.27.101", "23.121.45.220", "206.27.34.178", "174.82.96.35", "13.234.26.45", "245.213.200.10", "167.38.92.14", "27.98.32.45", "22.48.92.13" };
            sbyte[] family = Bytes.toBytes("details");
            sbyte[] pageCol = Bytes.toBytes("page");
            sbyte[] ipCol = Bytes.toBytes("ip");
            for (int i = 0; i < totalRecords; i++)
            {
                sbyte[] rowkey = Bytes.toBytes(i);
                string randomIP = ipAdrs[rand.Next(ipAdrs.Length)];
                string randomPage = pages[rand.Next(pages.Length)];
                Put put = new Put(rowkey);
                put.add(family, ipCol, Bytes.toBytes(randomIP));
                put.add(family, pageCol, Bytes.toBytes(randomPage));
                htable.put(put);
            }
            htable.flushCommits();
            htable.close();
        }
    }
}
